package tech.loedige;

import util.Dump;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class Main {

    public static void main(String[] args) throws IOException, NoSuchAlgorithmException {
	    //import the files
        Path pdfOne = Paths.get("./shattered-1.pdf");
        byte[] byteOne = Files.readAllBytes(pdfOne);
        Path pdfTwo = Paths.get("./shattered-2.pdf");
        byte[] byteTwo = Files.readAllBytes(pdfTwo);

        //calculate the SHA1-Hashes
        var md = MessageDigest.getInstance("SHA-1");
        System.out.println("SHA-1 von PDF1: " + Dump.dumpString(md.digest(byteOne)));
        System.out.println("SHA-1 von PDF2: " + Dump.dumpString(md.digest(byteTwo)));

        System.out.println("Anzahl der unterschiedlichen Bits:" + noOfDiffBits(byteOne,byteTwo));
    }

    public static int noOfDiffBits(byte[] ba1, byte[] ba2)
    {
        if( ba1 == null || ba2 == null || ba1.length != ba2.length ) {
            throw new IllegalArgumentException("Length of input byte arrays must be equal!");
        }
        int ctr = 0;
        for( int i = 0; i < ba1.length; ++i ) {
            int bc = Integer.bitCount((ba1[i] ^ ba2[i]) & 0xff);
            ctr += bc;
            if(bc!=0){
                System.out.println("Unterschied bei Byte: " + (i + 1));
            }
            }
        return ctr;
    }
}
